#include "Environment.h"
#include "RenderSampler.h"
#include "GlRenderer.h"

namespace GtpVisibilityPreprocessor {


RenderSampler::RenderSampler():Preprocessor()
{
  environment->GetIntValue("RenderSampler.samples", mSamples);
  cout<<"mspamples"<<mSamples<<endl;
}

bool
RenderSampler::ComputeVisibility()
{
  
  cout<<"HERE I WAS!\n";

  vector<RenderCostSample> samples;
  
  if (renderer)
	renderer->SampleRenderCost(
							   mSamples,
							   samples
							   );


  // compute histogram from the samples
  int bins = 100;
  int maxPvs = 0;

  vector<int> histogram(bins);
  
  int i;
  for (i = 0; i < bins; i++)
	histogram[i] = 0;
  
  for (i = 0; i < mSamples; i++) {
	if (samples[i].mVisibleObjects > maxPvs)
	  maxPvs = samples[i].mVisibleObjects;
  }
  
  for (i = 0; i < mSamples; i++) {
	int bin = (samples[i].mVisibleObjects*bins)/maxPvs;
	histogram[bin]++;
  }

  // output the histogram
  for (i = 0; i < bins; i++) {
	cout<<histogram[i]<<endl;
  }

  
  return true;
}

}
